/*!
 * Copyright (C) 2010-2012 Kazo Vision. (http://www.kazovision.com)
 * All rights reserved.
 * 
 * MD5
 * ļMD5ࡣ
 * 
 * @version 0.01
 * @author lyq (kazovision.liang@gmail.com)
 */

package com.kazovision.pvdaemon.common;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class MD5 {
	/** 
	 * Ĭϵַϣֽת 16 Ʊʾַ,apacheУصļȷõľĬϵ 
	*/
	protected static char hexDigits[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f' };
	
	protected static MessageDigest messagedigest = null;
	static {
		try {
			messagedigest = MessageDigest.getInstance("MD5");
		} catch (NoSuchAlgorithmException nsaex) {
			System.err.println(MD5.class.getName()+ "ʼʧܣMessageDigest֧MD5Util");
			nsaex.printStackTrace();
		}
	}
	
	/** 
	 * ַmd5Уֵ 
	 *  
	 * @param s 
	 * @return 
	*/
	public static String getMD5String(String s) {
		return getMD5String(s.getBytes());
	}
	
	/** 
	 * жַmd5УǷһ֪md5ƥ 
	 *  
	 * @param password ҪУַ 
	 * @param md5PwdStr ֪md5У 
	 * @return 
	*/  
	public static boolean checkPassword(String password, String md5PwdStr) {
		String s = getMD5String(password);
		return s.equals(md5PwdStr);
	}
	
	/** 
	 * ļmd5Уֵ 
	 *  
	 * @param file 
	 * @return 
	 * @throws IOException 
	*/
	public static String getFileMD5String(File file) throws IOException {
		InputStream fis;  
		fis = new FileInputStream(file);
		byte[] buffer = new byte[1024];
		int numRead = 0;
		while ((numRead = fis.read(buffer)) > 0) {
			messagedigest.update(buffer, 0, numRead);
		}  
		fis.close();
		return bufferToHex(messagedigest.digest());
	}
	
	/** 
	 * JDK1.4в֧MappedByteBufferΪupdateҪMappedByteBuffer 
	 * ԭǵʹ FileChannel.map ʱMappedByteBuffer Ѿϵͳռһ 
	 * ʹ FileChannel.close ޷ͷģFileChannelûṩ unmap ķ 
	 * ˻޷ɾļ 
	 *  
	 * Ƽʹ 
	 *  
	 * @param file 
	 * @return 
	 * @throws IOException 
	*/
	public static String getFileMD5String_old(File file) throws IOException {
		FileInputStream in = new FileInputStream(file);
		FileChannel ch = in.getChannel();
		MappedByteBuffer byteBuffer = ch.map(FileChannel.MapMode.READ_ONLY, 0, file.length());  
		messagedigest.update(byteBuffer);
		return bufferToHex(messagedigest.digest());
	}
	
	public static String getMD5String(byte[] bytes) {
		messagedigest.update(bytes);
		return bufferToHex(messagedigest.digest());
	}
	
	private static String bufferToHex(byte bytes[]) {
		return bufferToHex(bytes, 0, bytes.length);
	}
	
	private static String bufferToHex(byte bytes[], int m, int n) {
		StringBuffer stringbuffer = new StringBuffer(2 * n);
		int k = m + n;
		for (int l = m; l < k; l++) {
			appendHexPair(bytes[l], stringbuffer);
		}
		return stringbuffer.toString();
	}
	
	private static void appendHexPair(byte bt, StringBuffer stringbuffer) {
		char c0 = hexDigits[(bt & 0xf0) >> 4];// ȡֽи 4 λת, >>> Ϊ߼ƣλһ,˴δַкβͬ   
		char c1 = hexDigits[bt & 0xf];// ȡֽе 4 λת   
		stringbuffer.append(c0);
		stringbuffer.append(c1);
	}
	
	/*
	public static void main(String[] args) throws IOException {
		long begin = System.currentTimeMillis();
		
		File file = new File("C:/12345.txt");
		String md5 = getFileMD5String(file);
		long end = System.currentTimeMillis();
		System.out.println("md5:" + md5 + " time:" + ((end - begin) / 1000) + "s");
	}
	*/
}
