/*!
 * Copyright (C) 2010-2012 Kazo Vision. (http://www.kazovision.com)
 * All rights reserved.
 * 
 * TempPath
 * ʱĿ¼ࡣ
 * 
 * @version 0.01
 * @author lyq (kazovision.liang@gmail.com)
 */

package com.kazovision.pvdaemon.common;

import java.io.File;
import java.util.UUID;

import net.lingala.zip4j.core.ZipFile;
import net.lingala.zip4j.exception.ZipException;
import android.util.Log;

public class TempPath {
	private static final String TAG = "TempPath";
	private String mTempPath;
	
	public TempPath() throws Exception {
		//tempĿ¼´һʱĿ¼
		UserPath userpath = new UserPath();
		mTempPath = userpath.GetUserSubPath("temp") + UUID.randomUUID() + File.separator; 
		File file = new File(mTempPath);
		if (! file.exists()) {
			if (! file.mkdirs()) {
				Log.e(TAG, "Error when make temp path.");
				throw new Exception("Error when make temp path.");
			}
		}
	}
	
	public String GetTempPath(){
		return mTempPath;
	}
	
	public void ExtractToTempPath(String pFileName, String pPassword) throws Exception{
		try {
			ZipFile zipFile = new ZipFile(pFileName);
			if (zipFile.isEncrypted()) {
				zipFile.setPassword(pPassword);
			}
			zipFile.extractAll(mTempPath);
		}
		catch (ZipException e) {
			Log.e(TAG, String.format("Error when extract file '%s - %s'.", e.getClass().getName(), e.getMessage()));
			throw new Exception(String.format("Error when extract file '%s'.", pFileName));
		}
	}
	
	//ɾʱļ
	public void DeleteTempPath(String pPath) throws Exception {
		File dir = new File(pPath);
		File[] files = dir.listFiles();
		if (files == null) {
			return;
		}
		for (int i = 0; i < files.length; i++) {
			if (files[i].isDirectory()) {
				DeleteTempPath(files[i].getAbsolutePath());
			}
			else {
				if (! files[i].delete()) {
					Log.e(TAG, String.format("Error when delete file '%s'.", files[i].getAbsoluteFile()));
					throw new Exception("Error when delete file.");
				}
			}
		} 
	}
}
