/*!
 * Copyright (C) 2010-2012 Kazo Vision. (http://www.kazovision.com)
 * All rights reserved.
 * 
 * UserPath
 * ûĿ¼ϵͳĿ¼ࡣ
 * 
 * @version 0.01
 * @author lyq (kazovision.liang@gmail.com)
 */

package com.kazovision.pvdaemon.common;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;

import android.os.Environment;
import android.util.Log;

public class UserPath {
	private static final String TAG = "UserPath";
	
	public static void ClearPath(String pPath, boolean pStopOnFailed) throws Exception {
		File f = new File(pPath);
		if (f.exists() && f.isDirectory()) {
			File files[] = f.listFiles();
			for (int i=0; i<files.length; i++) {
				if (files[i].isDirectory()) {
					ClearPath(files[i].getAbsolutePath(), pStopOnFailed);
					if (! files[i].delete()) {
						if (pStopOnFailed) {
							throw new Exception(String.format("Error when delete folder '%s'.", files[i].getAbsoluteFile()));
						}
					}
				}
				else {
					if (! files[i].delete()) {
						if (pStopOnFailed) {
							throw new Exception(String.format("Error when delete file '%s'.", files[i].getAbsoluteFile()));
						}
					}
				}
			}
		}
	}
	
	public static void CopyPath(String pSrcPath, String pDesPath) throws Exception {
		File f = new File(pDesPath);
		if (! f.exists()) {
			if (! f.mkdirs()) {
				throw new Exception(String.format("Error when crewate folder '%s'.", f.getAbsoluteFile()));
			}
		}
		File sf = new File(pSrcPath);
		File files[] = sf.listFiles();
		for (int i=0; i<files.length; i++) {
			if (files[i].isDirectory()) {
				String despath = pDesPath + File.separator + files[i].getName();
				CopyPath(files[i].getAbsolutePath(), despath);
			}
			else {
				String desfile = pDesPath + File.separator + files[i].getName();
				File df = new File(desfile);
				FileInputStream instream = new FileInputStream(files[i]);
				FileOutputStream outstream = new FileOutputStream(df);
				byte[] buffer = new byte[1024 * 5];
				while (true) {
					int readedsize = instream.read(buffer);
					if (readedsize < 0) {
						break;
					}
					outstream.write(buffer, 0, readedsize);
				}
				instream.close();
				outstream.close();
			}
		}
	}
	
	private String mUserPath;
	
	public UserPath() {
		File file = Environment.getExternalStoragePublicDirectory("pvplayer");
		if (! file.exists()) {
			if (! file.mkdirs()) {
				Log.e(TAG, String.format("Error when create user path."));
			}
		}
		mUserPath = file.getAbsolutePath();
	}
	
	public String GetUserPath(){
		return mUserPath + File.separator;
	}
	
	public String GetUserSubPath(String pSubPathName, boolean pCreatePath) {
		String path = mUserPath + File.separator + pSubPathName + File.separator;
		File file = new File(path);
		if ((! file.exists()) && (pCreatePath)) {
			if (! file.mkdirs()) {
				Log.e(TAG, String.format("Error when create path '%s'.", path));
			}
		}
		return path;
	}
	
	public String GetUserSubPath(String pSubPathName) {
		return GetUserSubPath(pSubPathName, true);
	}
}