/*!
 * Copyright (C) 2010-2012 Kazo Vision. (http://www.kazovision.com)
 * All rights reserved.
 * 
 * CommandProcessThread
 * ִָ̡߳
 * 
 * @version 0.01
 * @author tony (tonixinot@gmail.com)
 */

package com.kazovision.pvdaemon.communicate;

import android.util.Log;

public class CommandProcessThread extends Thread{
	private static final String TAG = "CommandProcessThread";
	private CommunicateController mCommunicateController;
	
	public CommandProcessThread(CommunicateController pCommunicateController){
		mCommunicateController = pCommunicateController;
	}
	
	@Override
	public void start() {
		setName("Command Process Thread");
		super.start();
	}
	
	public void run() {
		while (! interrupted()) {
			try {
				sleep(3 * 1000);
			}
			catch (InterruptedException ex) {
				Log.e(TAG, "Command process thread inturrepted.");
				break;
			}
			
			try {
				mCommunicateController.ProcessOneCommand();
			}
			catch (Exception e) {
				Log.e(TAG, String.format("Error occurred during process command: '%s - %s'.", e.getClass().getName(), e.getMessage()));
			}
		}
	}

}
