/*!
 * Copyright (C) 2010-2012 Kazo Vision. (http://www.kazovision.com)
 * All rights reserved.
 * 
 * CommunicateThread
 * նͨѶ̡߳
 * 
 * @version 0.01
 * @author tony (tonixinot@gmail.com)
 */

package com.kazovision.pvdaemon.communicate;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import android.content.Context;
import android.util.Log;

import com.kazovision.pvdaemon.common.UserPath;

public class CommunicateThread extends Thread {
	private static final String TAG = "CommunicateThread";
	private Context mContext;
	private CommunicateController mCommunicateController;
	
	public CommunicateThread(Context pContext, CommunicateController pCommunicateController){
		mContext = pContext;
		mCommunicateController = pCommunicateController;
	}
	
	@Override
	public void start() {
		setName("Communicate Thread");
		super.start();
	}
	
	public void run() {
		//WEBַΪգĬϵַȥ
		if (GetWebServerUrlInfo() == "") {
			try {
				SetWebServerUrlInfo("http://pvmanager.kazovision.com");
			}
			catch (Exception e) {
				Log.e(TAG, String.format("Error when set default web sesrver url: '%s - %s'.", e.getClass().getName(), e.getMessage()));
			}
		}
		
		while (! interrupted()) {
			int webcommunicationinterval = GetWebCommunicationIntervalInfo();
			try {
				sleep(webcommunicationinterval * 1000);
			}
			catch (InterruptedException ex) {
				Log.e(TAG, "Communicate thread inturrepted.");
				break;
			}
			
			//TODO: ʵHTTPSͨѶοhttp://stackoverflow.com/questions/12060514/httpsurlconnection-getcontent-nullpointerexception-with-ics
			try {
				HttpClient httpclient = new DefaultHttpClient();
				HttpPost request = new HttpPost(GetWebServerUrlInfo() + "/TerminalRequestService.do");
				List<NameValuePair> params = new ArrayList<NameValuePair>();
				String requestcontents = mCommunicateController.PrepareRequestContents();
				params.add(new BasicNameValuePair("content", requestcontents));
				UrlEncodedFormEntity entity = new UrlEncodedFormEntity(params, "utf-8");
				request.setEntity(entity);
				HttpResponse response = httpclient.execute(request);
				BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent()));
				String line = null;
				StringBuffer contentsbuffer = new StringBuffer("");
				while ((line = reader.readLine()) != null) {
					contentsbuffer.append(line);
				}
				String contents = contentsbuffer.toString().trim();
				if (! mCommunicateController.ProcessReturnContents(contents)) {
					if (contents.equals("ERROR")) {
						SetWebServerCommunicateResultInfo("Server returned ERROR.");
					}
					else if (contents.equals("UPGRADE")) {
						SetWebServerCommunicateResultInfo("Server returned UPGRADE.");
					}
					else {
						SetWebServerCommunicateResultInfo("Error when process contents.");
					}
				}
				else {
					SetWebServerCommunicateResultInfo("SUCCESS");
				}
			}
			catch (Exception e) {
				Log.e(TAG, String.format("Error occurred during communication: '%s - %s'.", e.getClass().getName(), e.getMessage()));
				try {
					SetWebServerCommunicateResultInfo(e.getMessage());
				}
				catch (Exception ex) {
					Log.e(TAG, "Error when write communicate result.");
				}
			}
		}
	}
	
	private int GetWebCommunicationIntervalInfo() {
		//TOOD: webͨѶɿõġ
		return 30;
	}
	
	private String GetWebServerUrlInfo() {
		try {
			UserPath userpath = new UserPath();
			FileReader filereader = new FileReader(userpath.GetUserPath() + "webserverurl");
			BufferedReader bufferedreader = new BufferedReader(filereader);
			String webserverurl = bufferedreader.readLine();
			bufferedreader.close();
			if (webserverurl == null) {
				webserverurl = "";
			}
			return webserverurl;
		}
		catch (Exception e) {
			return "";
		}
	}
	
	private void SetWebServerUrlInfo(String pWebServerUrl) throws Exception {
		UserPath userpath = new UserPath();
		FileWriter filewriter = new FileWriter(userpath.GetUserPath() + "webserverurl");
		BufferedWriter bufferedwriter = new BufferedWriter(filewriter);
		bufferedwriter.write(pWebServerUrl);
		bufferedwriter.flush();
		bufferedwriter.close();
	}
	
	private void SetWebServerCommunicateResultInfo(String pResult) throws Exception {
		UserPath userpath = new UserPath();
		FileWriter filewriter = new FileWriter(userpath.GetUserSubPath("ram") + "webservercommunicateresult");
		BufferedWriter bufferedwriter = new BufferedWriter(filewriter);
		bufferedwriter.write(pResult);
		bufferedwriter.flush();
		bufferedwriter.close();
	}
}
