/*!
 * Copyright (C) 2010-2012 Kazo Vision. (http://www.kazovision.com)
 * All rights reserved.
 * 
 * UpdateContentCommandProcessor
 * ½Ŀָࡣ
 * 
 * @version 0.01
 * @author lyq (kazovision.liang@gmail.com)
 */

package com.kazovision.pvdaemon.communicate.commandprocessor;

import java.io.File;
import java.net.URL;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import android.content.Context;
import android.util.Log;

import com.kazovision.pvdaemon.common.TempPath;
import com.kazovision.pvdaemon.common.UserPath;
import com.kazovision.pvdaemon.communicate.CommandCacheDB;
import com.kazovision.pvdaemon.communicate.CommandCacheInfo.CommandExecuteStatus;
import com.kazovision.pvdaemon.download.DownloadController;
import com.kazovision.pvdaemon.fileimport.PackageFileImporter;

public class UpdateContentCommandProcessor extends BaseCommandProcessor {
	private static final String TAG = "UpdateContentCommandProcessor";
	private static final int DOWNLOAD_FLAG_PACKAGE = 1;
	private static final int DOWNLOAD_FLAG_MEDIA = 2;
	private static final String PACKAGE_PASSWORD = "Oht0ciatiaViP9ai";
	
	public UpdateContentCommandProcessor(Context pContext, CommandCacheDB pCommandCacheDB, DownloadController pDownloadController) {
		super(pContext, pCommandCacheDB, pDownloadController);
	}
	
	@Override
	public void ProcessCommand(Element pCommandElement,CommandExecuteStatus pExecuteStatus) {
		try {
			int commandid = Integer.parseInt(pCommandElement.getAttribute("commandid"));
			if (pExecuteStatus == CommandExecuteStatus.WaitingForExecute) { //״δָҪصļ Download ģ
				NodeList fileNodeList = pCommandElement.getElementsByTagName("file");
				Element fileelement = (Element)fileNodeList.item(0);
				String[] fileurl = new String[2];
				fileurl[0] = fileelement.getAttribute("url");
				fileurl[1] = fileelement.getAttribute("md5");
				//ض
				DownloadFiles(commandid,fileurl, DOWNLOAD_FLAG_PACKAGE);
				mExecuteStatus = CommandExecuteStatus.WaitingForDownload;
				mReturnContents = "";
			}
			else if (pExecuteStatus == CommandExecuteStatus.WaitingForDownload){ //ļأʽָ
				String[] fileinfo;
				fileinfo = GetDownloadedFiles(commandid, DOWNLOAD_FLAG_PACKAGE);
				if (fileinfo == null) {
					Log.e(TAG, "Error when get downloaded files.");
					throw new Exception("Error when get downloaded files.");
				}
				TempPath temppath = new TempPath();
				temppath.ExtractToTempPath(fileinfo[1], PACKAGE_PASSWORD);
				//Ƿ download.xml ļǵĻ˵Ҫصļ
				String downloadfilename = temppath.GetTempPath() + "download.xml";
				File file = new File(downloadfilename);
				if (file.exists()){ //download.xml ڣ˵Ҫصļ
					//Ҫصļ
					List<String[]> fileurllist = new ArrayList<String[]>();
					DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
					DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
					Document document = documentBuilder.parse(file);
					Element downloadelement = document.getDocumentElement();
					String serverurl = downloadelement.getAttribute("serverurl");
					NodeList fileNodeList = downloadelement.getChildNodes();
					for (int i = 0;i < fileNodeList.getLength();i++ ){
						Element fileelement = (Element) fileNodeList.item(i);
						UserPath userpath = new UserPath();
						String filepoolpath = userpath.GetUserSubPath("filepool");
						String filename = filepoolpath + fileelement.getAttribute("filename");
						File file1 = new File(filename);
						if (!file1.exists()){
							String[] fileurl= new String[2];
							fileurl[0] = serverurl + "/" + fileelement.getAttribute("filename");
							fileurl[1] = fileelement.getAttribute("md5");
							fileurllist.add(fileurl);
						}
					}
					if (fileurllist.size() == 0) {	//ļعֱӼؽĿ
						NodeList informationNodeList = pCommandElement.getElementsByTagName("information");
						Element informationelement = (Element)informationNodeList.item(0);
						String informationid = informationelement.getAttribute("id");
						PackageFileImporter importer = new PackageFileImporter(mContext);
						Date publishtime = Calendar.getInstance().getTime();
						importer.LoadFromPackageFolder(informationid, "web", publishtime, temppath.GetTempPath());
						mExecuteStatus = CommandExecuteStatus.ExecuteSuccess;
						mReturnContents = "";
					}
					else { //ýļء
						DownloadFiles(commandid, fileurllist, DOWNLOAD_FLAG_MEDIA);
						mExecuteStatus = CommandExecuteStatus.WaitingForDownloadEx;
						mReturnContents = "";
					}
				}
				else { //download.xml ڣֱӼظýĿ
					NodeList informationNodeList = pCommandElement.getElementsByTagName("information");
					Element informationelement = (Element) informationNodeList.item(0);
					String informationid = informationelement.getAttribute("id");
					PackageFileImporter importer = new PackageFileImporter(mContext);;
					Date publishtime = Calendar.getInstance().getTime();
					importer.LoadFromPackageFolder(informationid, "web", publishtime, temppath.GetTempPath());
					mExecuteStatus = CommandExecuteStatus.ExecuteSuccess;
					mReturnContents = "";
				}
			}
			else if (pExecuteStatus == CommandExecuteStatus.WaitingForDownloadEx) {		//ظزļļȫأʽؽĿ
				//ѹԭʼĽĿļ
				String[] fileinfo;
				fileinfo = GetDownloadedFiles(commandid, DOWNLOAD_FLAG_PACKAGE);
				TempPath temppath = new TempPath();
				temppath.ExtractToTempPath(fileinfo[1], PACKAGE_PASSWORD);
				//صزļ
				List<String[]> fileinfolist = GetDownloadedFilesList(commandid, DOWNLOAD_FLAG_MEDIA);
				//زļƵĿѹʱĿ¼¡
				for (String[] fileinfo1 : fileinfolist) {
					URL url = new URL(fileinfo1[0]);
					String filename = new File(url.getFile()).getName();
					String newfilename = temppath.GetTempPath() + filename;
					File newfile = new File(newfilename);
					File localfile = new File(fileinfo1[1]);
					localfile.renameTo(newfile);
				}
				//ؽĿ
				NodeList informationNodeList = pCommandElement.getElementsByTagName("information");
				Element informationelement = (Element) informationNodeList.item(0);
				String informationid = informationelement.getAttribute("id");
				PackageFileImporter importer = new PackageFileImporter(mContext);
				Date publishtime = Calendar.getInstance().getTime();
				importer.LoadFromPackageFolder(informationid, "web", publishtime, temppath.GetTempPath());
				mExecuteStatus = CommandExecuteStatus.ExecuteSuccess;
				mReturnContents = "";
			}
			else {
				Log.e(TAG, "Unknown execute status.");
				throw new Exception("Unknown execute status.");
			}
		}
		catch (Exception e) {
			Log.e(TAG, String.format("Error when process command '%s - %s'.", e.getClass().getName(), e.getMessage()));
			mExecuteStatus = CommandExecuteStatus.ExecuteFailed;
			mReturnContents = FormatErrorMessage(e.getClass().getName() + "-" + e.getMessage());
		}
	}
}
