/*!
 * Copyright (C) 2010-2013 Kazo Vision. (http://www.kazovision.com)
 * All rights reserved.
 * 
 * UpdateTerminalNameCommandProcessor
 * նָ
 * 
 * @version 0.01
 * @author lyq (kazovision.liang@gmail.com)
 */

package com.kazovision.pvdaemon.communicate.commandprocessor;

import java.io.BufferedWriter;
import java.io.FileWriter;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import android.content.Context;
import android.util.Log;

import com.kazovision.pvdaemon.common.UserPath;
import com.kazovision.pvdaemon.communicate.CommandCacheDB;
import com.kazovision.pvdaemon.communicate.CommandCacheInfo.CommandExecuteStatus;
import com.kazovision.pvdaemon.download.DownloadController;

public class UpdateTerminalNameCommandProcessor  extends BaseCommandProcessor{
	private static final String TAG = "UpdateTerminalNameCommandProcessor";

	public UpdateTerminalNameCommandProcessor(Context pContext, CommandCacheDB pCommandCacheDB, DownloadController pDownloadController){
		super(pContext, pCommandCacheDB, pDownloadController);
	}

	@Override
	public void ProcessCommand(Element pCommandElement,CommandExecuteStatus pExecuteStatus) {
		try {
			NodeList terminalNodeList = pCommandElement.getElementsByTagName("terminalname");
			if (terminalNodeList.getLength() == 0) {
				throw new Exception("Terminal name element not exists.");
			}
			Element terminalelement = (Element)terminalNodeList.item(0);
			String terminalname = terminalelement.getAttribute("value");
			if (terminalname.length() == 0) {
				Log.i(TAG, "Terminal name is empty.");
			}
			SetTerminalNameInfo(terminalname);
			Log.i(TAG, String.format("Terminal name been modified '%s'.", terminalname));
			mExecuteStatus = CommandExecuteStatus.ExecuteSuccess;
			mReturnContents = "";
		}
		catch (Exception e) {
			Log.e(TAG, String.format("Error when process command '%s - %s'.", e.getClass().getName(), e.getMessage()));
			mExecuteStatus = CommandExecuteStatus.ExecuteFailed;
			mReturnContents = FormatErrorMessage(e.getClass().getName() + "-" + e.getMessage());
		}
	}
	
	private void SetTerminalNameInfo(String pTerminalName) throws Exception {
		UserPath userpath = new UserPath();
		FileWriter filewriter = new FileWriter(userpath.GetUserPath() + "terminalname");
		BufferedWriter bufferedwriter = new BufferedWriter(filewriter);
		bufferedwriter.write(pTerminalName);
		bufferedwriter.flush();
		bufferedwriter.close();
	}
}
