/*!
 * Copyright (C) 2010-2013 Kazo Vision. (http://www.kazovision.com)
 * All rights reserved.
 * 
 * DownloadHelper
 * ذࡣ
 * 
 * @version 0.01
 * @author lianghong (lh_ann@163.com)
 */

package com.kazovision.pvdaemon.download;

import android.util.Log;

import com.kazovision.pvdaemon.communicate.CommandCacheDB;

public class DownloadHelper {
	private static final String TAG = "DownloadHelper";
	private CommandCacheDB mCommandCacheDB;
	public DownloadHelper(CommandCacheDB pCommandCacheDB) {
		mCommandCacheDB = pCommandCacheDB;
	}
	
	public boolean NotifyDownloadProgress(String pFileUrl, int pDownloadProgress) {
		try {
			mCommandCacheDB.UpdateFileDownloadProgress(pFileUrl, pDownloadProgress);
		} catch (Exception e) {
			Log.e(TAG, e.getStackTrace().toString());
		}
		return true;
	}
	
	public boolean NotifyDownloadFinished(String pFileUrl, String pLocalFileName) {
		try {
			mCommandCacheDB.SetFileDownloadFinished(pFileUrl, pLocalFileName);
		} catch (Exception e) {
			Log.e(TAG, e.getStackTrace().toString());
		}
		return true;
	}
}
