/*!
 * Copyright (C) 2010-2013 Kazo Vision. (http://www.kazovision.com)
 * All rights reserved.
 * 
 * DownloadNotifyThread
 * ̡֪ͨ߳
 * 
 * @version 0.01
 * @author lianghong (lh_ann@163.com)
 */

package com.kazovision.pvdaemon.download;

import java.util.ArrayList;
import java.util.List;

import android.util.Log;

import com.kazovision.pvdaemon.download.DownloadInfo.FileDownloadStatus;

public class DownloadNotifyThread extends Thread {
	private static final String TAG = "DownloadNotifyThread";
	private DownloadController mDownloadController;
	private List<DownloadHelper> mDownloadHelperList = new ArrayList<DownloadHelper>();
	
	public DownloadNotifyThread(DownloadController pDownloadController) {
		mDownloadController = pDownloadController;
	}
	
	@Override
	public void start() {
		setName("DownloadNotify Thread");
		super.start();
	}
	
	public boolean AppendDownloadHelper(DownloadHelper pDownloadHelper) {
		mDownloadHelperList.add(pDownloadHelper);
		return true;
	}
	
	public boolean RemoveDownloadHelper(DownloadHelper pDownloadHelper) {
		mDownloadHelperList.remove(pDownloadHelper);
		return true;
	}
	
	public void run() {
		while(! interrupted()) {
			//ȡ֪ͨϢ֪ͨⲿ
			List<DownloadInfo> downloadinfolist = mDownloadController.GetWaitingForNotifyDownloadInfoList();
			if (downloadinfolist.size() == 0) {
				try {
					sleep(10000);
					continue;
				} catch (InterruptedException e) {
					Log.e(TAG, "Download notifythread inturrepted.");
					break;
				}
			}
			for (DownloadInfo downloadInfo : downloadinfolist) {
				//֪ͨļϡ
				if ((downloadInfo.GetDownloadStatus() == FileDownloadStatus.DownloadSucceed) || (downloadInfo.GetDownloadStatus() == FileDownloadStatus.DownloadFailed)) {
					for (DownloadHelper downloadhelper : mDownloadHelperList) {
						if (downloadhelper.NotifyDownloadFinished(downloadInfo.GetFileUrl(), downloadInfo.GetLocalFileName())) {
							break;
						}
					}
				}
				else {
					for (DownloadHelper downloadhelper : mDownloadHelperList) {
						if (downloadhelper.NotifyDownloadProgress(downloadInfo.GetFileUrl(), downloadInfo.GetDownloadProgress())) {
							break;
						}
					}
				}
				//ϢΪ֪ͨ
				mDownloadController.SetDownloadInfoNotified(downloadInfo.GetID());
			}
			//õϢļ
			mDownloadController.ClearUselessDownloadInfo();
		}
	}
}
