/*!
 * Copyright (C) 2010-2012 Kazo Vision. (http://www.kazovision.com)
 * All rights reserved.
 * 
 * PackageFileImporter
 * Ŀļࡣ
 * 
 * @version 0.01
 * @author lyq (kazovision.liang@gmail.com)
 */

package com.kazovision.pvdaemon.fileimport;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Locale;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import android.content.Context;
import android.util.Log;

import com.kazovision.pvdaemon.common.TempPath;
import com.kazovision.pvdaemon.common.UserPath;
import com.kazovision.pvdaemon.playercontrol.PlayerController;

public class PackageFileImporter {
	private static final String TAG = "PackageFileImporter";
	private static final String PackagePassword = "Oht0ciatiaViP9ai";
	private Context mContext;
	
	public PackageFileImporter(Context pContext){
		mContext = pContext;
	}
	
	public void LoadFromPackageFile(String pInformationID, String pPublishType, Date pPublishTime, List<String> pPackageFileList) throws Exception {
		Log.i(TAG, String.format("Loading package file '%s'-'%s'.", pInformationID, pPackageFileList.toArray(new String[pPackageFileList.size()])));
		TempPath tempPath = new TempPath();
		for (String filename : pPackageFileList){
			tempPath.ExtractToTempPath(filename, PackagePassword);
		}
		LoadFromFolder(pInformationID, pPublishType, pPublishTime, tempPath.GetTempPath());
		
		Log.i(TAG, String.format("Package '%s' been loaded.", pInformationID));
	}
	
	public void LoadFromPackageFile(String pInformationID, String pPublishType, Date pPublishTime, String pPackageFile) throws Exception {
		Log.i(TAG, String.format("Loading package file '%s'-'%s'.", pInformationID, pPackageFile));
		TempPath tempPath = new TempPath();
		tempPath.ExtractToTempPath(pPackageFile, PackagePassword);
		LoadFromFolder(pInformationID, pPublishType, pPublishTime, tempPath.GetTempPath());
		
		Log.i(TAG, String.format("Package '%s' been loaded.", pInformationID));
	}
	
	public void LoadFromPackageFolder(String pInformationID, String pPublishType, Date pPublishTime, String pPackagePath) throws Exception {
		Log.i(TAG, String.format("Loading package file '%s'-'%s'.", pInformationID, pPackagePath));
		LoadFromFolder(pInformationID, pPublishType, pPublishTime, pPackagePath);
		
		Log.i(TAG, String.format("Package '%s' been loaded.", pInformationID));
	}
	
	private void LoadFromFolder(String pInformationID, String pPublishType, Date pPublishTime, String pPackagePath) throws Exception {
		//ȡĿ͡
		String contenttype;
		try {
			FileReader filereader = new FileReader(pPackagePath + File.separator + "contenttype.xml");
			BufferedReader bufferedreader = new BufferedReader(filereader);
			contenttype = bufferedreader.readLine();
			bufferedreader.close();
			if (contenttype == null || contenttype.equals("")) {
				contenttype = "NORMAL";
			}
		}
		catch (Exception e) {
			contenttype = "NORMAL";
		}
		
		File dir = new File(pPackagePath);
		File file[] = dir.listFiles();
		for (int i = 0; i < file.length; i++) {
			if (file[i].isDirectory()){
				continue;
			}
			
			File localfile = file[i];
			String suffix = GetFileExtension(localfile);
			if (suffix.equals("xml") || suffix.equals("psc")) { //.xml,.pscļƶ
				continue;
			}
			
			//1.ýļƶpvplayerĿ¼
			//pvplayerĿfilepool·
			UserPath userpath = new UserPath();
			String resfilepath = userpath.GetUserSubPath("filepool");
			//filepoolĿ¼ǷѾͬļɾ
			String resfilename = resfilepath + localfile.getName();
			File resfile = new File(resfilename);
			if (resfile.exists()) {
				resfile.delete();
			}
			//ļƶfilepoolĿ¼
			localfile.renameTo(resfile);
			localfile.delete();
			
			//2.Ϊýļ½һ.infoļ¼ļʹʱ
			String infofilename = resfilename + ".info";
			File infofile = new File(infofilename);
			if (infofile.exists()) {
				infofile.delete();
			}
			try {
				if (infofile.createNewFile()){
					//ļд뵱ǰϵͳʱ
					FileWriter fileWriter = new FileWriter(infofile);
					BufferedWriter bufwriter = new BufferedWriter (fileWriter);
					Date date = new java.util.Date();
					int time = (int) date.getTime();
					bufwriter.write(Integer.toString(time));
					bufwriter.flush(); //ˢ¸Ļ  
					bufwriter.close();
					fileWriter.close();
				}
			} catch (IOException e) {
				Log.e(TAG, "Error when write info file.");
				throw new Exception("Error when write info file.");
			}
		}
		
		//3.script_.xmlƶpvplayercontentsĿ¼
		String scriptfilename = pPackagePath + "script_.xml";
		File scriptfile = new File(scriptfilename);
		//pvplayerĿcontents·
		UserPath userpath = new UserPath();
		String newscriptfilepath = userpath.GetUserSubPath("contents");
		//contentsĿ¼ǷѾͬļɾ
		String newscriptfilename = newscriptfilepath + pInformationID + ".script";
		File newscriptfile = new File(newscriptfilename);
		if (newscriptfile.exists()) {
			newscriptfile.delete();
		}
		//ļƶcontentsĿ¼
		scriptfile.renameTo(newscriptfile);
		scriptfile.delete();
		
		//4.script_.xml .infoļ
		String infofilename = newscriptfilepath + pInformationID + ".info";
		File infofile = new File(infofilename);
		if (infofile.exists()){
			if (! infofile.delete()) {
				Log.e(TAG, "Error when delete original info file.");
			}
		}
		if (infofile.createNewFile()){
			//׼дļxml
			DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
			Document document = documentBuilder.newDocument();
			Element infoelement = document.createElement("info");
			document.appendChild(infoelement);
			infoelement.setAttribute("publishtype", pPublishType);
			SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss", Locale.ENGLISH);
			infoelement.setAttribute("publishtime", df.format(pPublishTime));
			//дinfoļ
			try {
				TransformerFactory transFactory = TransformerFactory.newInstance();
				Transformer transformer = transFactory.newTransformer();
				transformer.transform(new DOMSource(document), new StreamResult(infofile));
			}
			catch (Exception e) {
				Log.e(TAG, String.format("Error when save info file: '%s - %s'.", e.getClass().getName(), e.getMessage()));
				throw new Exception("Error when save info file.");
			}
		}
		
		//͸½Ŀָ
		PlayerController playercontroller = new PlayerController(mContext);
		playercontroller.ReloadContent(contenttype);
	}
	
	//ȡļ׺
	private String GetFileExtension(File pFile) {
		String ext = null;
		String s = pFile.getName();
		int i = s.lastIndexOf('.');
		if (i > 0 &&  i < s.length() - 1) {
			ext = s.substring(i+1).toLowerCase(Locale.ENGLISH);
		}
		if (ext == null) {
			ext = "";
		}
		return ext;
	}
}
